CodeForces 14C Four Segments

题目链接:http://codeforces.com/problemset/problem/14/C

题意:给出四条线段的端点,若这四条线段能组成一个平行于坐标轴的矩形,且面积为正,输出YES,反之NO。

分析:讨论,一共四个点,两条平行x,两条平行y,每条线段长度必须重复不小于2次。

代码:

#include<cstdio>
#include<cmath>
#include<cstring>
#include<queue>
#include<stack>
#include<cstdlib>
#include<iomanip>
#include<string>
#include<vector>
#include<map>
#include<string>
#include<iostream>
#include<algorithm>
using namespace std;
#define INF 0x3f3f3f3f
typedef long long ll;
#define Max(a,b) (a>b)?a:b
#define lowbit(x) x&(-x)

int main()
{
    map<int,map<int,int> >mp;
    map<int,int>mp1;
    int x[4],y[4],len=0,flag=1,x1[4],y1[4],xx=0,yy=0;
    for(int i=0; i<4; i++)
    {
        scanf("%d%d",&x[i],&y[i]);
        scanf("%d%d",&x1[i],&y1[i]);
        mp[x[i]][y[i]]++;
        mp[x1[i]][y1[i]]++;
        if((x1[i]==x[i])&&(y1[i]!=y[i]))
            yy++;
        else if((x1[i]!=x[i])&&(y1[i]==y[i]))
            xx++;
        else
            flag=0;
        len=abs(x1[i]-x[i]+y1[i]-y[i]);
        mp1[len]++;
    }
    if(xx!=yy)
        flag=0;
    for(int i=0; i<4; i++)
    {
        if(mp[x[i]][y[i]]!=2||mp[x1[i]][y1[i]]!=2)
            flag=0;
        len=abs(x1[i]-x[i]+y1[i]-y[i]);
        if(mp1[len]<2)
            flag=0;
    }
    if(flag)
        puts("YES");
    else
        puts("NO");
}

时间: 2024-10-08 20:04:32

CodeForces 14C Four Segments的相关文章

codeforces 895B XK Segments 二分 思维

codeforces 895B XK Segments 题目大意: 寻找符合要求的\((i,j)\)对,有:\[a_i \le a_j \] 同时存在\(k\),且\(k\)能够被\(x\)整除,\(k\)满足:\[a_i \le k \le a_j\] 思路: 整体数组排序,对于当前\(a_i\)寻找符合条件的\(a_j\)的最大值和最小值 有:\[(a_i-1)/x+k=a_j/x\] 所以可以通过二分查找获得,这里我寻找\(((a_i-1)/x+k)*x\)为下界,\(((a_i-1)/x

[Codeforces] Too Many Segments

Smaller input size: https://codeforces.com/contest/1249/problem/D1 Big input size: https://codeforces.com/contest/1249/problem/D2 Given n segments on a X coordinate line. Segments can intersect, lie inside each other or even coincide. The i-th segmen

codeforces 652D - Nested Segments

You are given n segments on a line. There are no ends of some segments that coincide. For each segment find the number of segments it contains. Input The first line contains a single integer n (1?≤?n?≤?2·105) - the number of segments on a line. Each

Codeforces 901C Bipartite Segments(Tarjan + 二分)

题目链接  Bipartite Segments 题意  给出一个无偶环的图,现在有$q$个询问.求区间$[L, R]$中有多少个子区间$[l, r]$ 满足$L <= l <= r <= R$,并且一个只包含$l$到$r$这些点的无向图为二分图. 因为整张图没有偶环,所以在这道题中如果某个无向图没有环,那个这个无向图就是二分图 Tarjan求出每个环的标号最小点和标号最大点. 令$f[i]$为能保证$[i, j]$这个区间构成的图都是二分图的$j$的最大值,则$f[i]$是不下降的 当

codeforces 652D Nested Segments 离散化+树状数组

题意:给你若干个区间,询问每个区间包含几个其它区间 分析:区间范围比较大,然后离散化,按右端点排序,每次更新树状数组中的区间左端点,查询区间和 注:(都是套路) #include<cstdio> #include<cstring> #include<queue> #include<cstdlib> #include<algorithm> #include<vector> #include<cmath> using name

Codeforces 193D Two Segments 解题报告

先是在蓝桥杯的网站上看到一道题: 给出1~n的一个排列,求出区间内所有数是连续自然数的区间的个数.n<=50000. 由于数据较弱,即使用O(N^2)的算法也能拿到满分. 于是在CF上发现了这一题: 给一个1~n的排列,在这个排列中选出两段区间,求使选出的元素排序后构成公差为1的等差数列的方案数.选出的两段区间中元素构成的集合相同时视为同一种方案.N<=300000. 可以发现CF的这题是上一题的强化版. 虽然蓝桥的题目是简化版,但正确的做法似乎没有CF这道题容易想到. 蓝桥的题首先想到的应该

Codeforces 901C. Bipartite Segments(思维题)

擦..没看见简单环..已经想的七七八八了,就差一步 显然我们只要知道一个点最远可以向后扩展到第几个点是二分图,我们就可以很容易地回答每一个询问了,但是怎么求出这个呢. 没有偶数简单环,相当于只有奇数简单环,没有环套环.因为如果有环套环,必定是两个奇数环合并1个或几个点,也就是同时保持奇数或者同时变为偶数,而我们知道奇数+奇数=偶数,偶数+偶数=偶数,所以就证明了只有奇数简单环,不存在环套环. 我们现在有一些点,再加入一个点,最多会形成一个环,并且一定是奇环,这时候,编号为1~环上的最小编号的点,

CodeForces 22D Segments 排序水题

题目链接:点击打开链接 右端点升序,取右端点 暴力删边 #include <cstdio> #include <cstring> #include <algorithm> #include <vector> #include <iostream> #include <map> #include <set> #include <math.h> using namespace std; #define inf 10

Codeforces Round #245 (Div. 2) A - Points and Segments (easy)

水到家了 #include <iostream> #include <vector> #include <algorithm> using namespace std; struct Point{ int index, pos; Point(int index_ = 0, int pos_ = 0){ index = index_; pos = pos_; } bool operator < (const Point& a) const{ return p